/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Point_$type, runOn, fromEnum, markType, PointUtil } from "igniteui-react-core";
import { ISeriesViewerInteractionManager_$type } from "./ISeriesViewerInteractionManager";
import { SeriesHighlightingManager } from "./SeriesHighlightingManager";
import { SeriesViewerScrollbarManager } from "./SeriesViewerScrollbarManager";
import { Rect } from "igniteui-react-core";
import { TileZoomManager } from "./TileZoomManager";
import { Size } from "igniteui-react-core";
import { MathUtil } from "igniteui-react-core";
import { MouseEventArgs } from "igniteui-react-core";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { truncate, intDivide, isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let SeriesViewerInteractionManager = /*@__PURE__*/ (() => {
    class SeriesViewerInteractionManager extends Base {
        constructor() {
            super();
            this.t = 0;
            this.u = 0;
            this.ai = null;
            this.q = 0;
            this.r = 0;
            this.p = 0;
            this.s = 0;
            this.i = false;
            this.aj = null;
            this.al = null;
            this.j = false;
            this.l = false;
            this.f = null;
            this.d = null;
            this.e = null;
            this.ak = null;
            this.am = null;
            this.c = null;
            this.a = null;
            this.h = false;
            this.ak = Rect.empty;
            this.aj = Rect.empty;
        }
        get f$d() {
            if (this.d == null) {
                this.d = new SeriesHighlightingManager();
            }
            return this.d;
        }
        get f$b() {
            if (this.e == null) {
                this.e = new SeriesViewerScrollbarManager();
            }
            return this.e;
        }
        f$ao(a, b) {
            let c = null;
            let d = null;
            let e = null;
            e = a.cu.e();
            let f;
            let g = ((() => { let h = a.cu.f(b, false, f, false); f = h.p2; return h.ret; })());
            if (g != e) {
                if (e != null && e.a3.a$c) {
                    e.a3.a$z(e, b, null, null, false);
                }
            }
            c = f;
            if (a != null) {
                a.ph(b);
            }
            if (g != null && !g.a3.a$c) {
                g.a3.a$y(g, b, c, d, false);
            }
        }
        f$a(a) {
            if (a.av != 0) {
                return a.av;
            }
            let b = 1;
            let c = false;
            let d = false;
            for (let e = 0; e < a.series.count; e++) {
                let f = a.series._inner[e];
                if (f.isStacked) {
                    f.n6((g) => {
                        if (g.bt == 2) {
                            c = true;
                        }
                        if (g.bt == 1) {
                            d = true;
                        }
                        return true;
                    });
                }
                else {
                    if (f.bt == 2) {
                        c = true;
                    }
                    if (f.bt == 1) {
                        d = true;
                    }
                }
            }
            if (d) {
                b = 1;
            }
            if (c) {
                b = 2;
            }
            if (c && d) {
                b = 3;
            }
            return b;
        }
        f$an(a) {
            let b = a.ti;
            let c = b;
            let d = a.cu;
            let e = a.du();
            let f = a.dx;
            let g = a.e8;
            let h = a.fh;
            if (!e) {
                c = { $type: Point_$type, x: NaN, y: NaN };
            }
            if (c.x < 0 || c.x > 1 || c.y < 0 || c.y > 1) {
                c = { $type: Point_$type, x: NaN, y: NaN };
            }
            for (let i = 0; i < a.series.count; i++) {
                let j = a.series._inner[i];
                j.oe(c);
            }
            a.mo(c);
            let k = a.cl == 0 && !a.ef && (a.d3 || f) && !g && !h;
            let l = a.t6;
            if (k && !isNaN_(b.x) && !l.isEmpty) {
                let m = l.width * (b.x - a.tr.left) / a.tr.width;
                d.eo(l.left + m, l.top, l.left + m, l.bottom);
                d.ed();
                d.ei(m);
            }
            else {
                d.cl();
            }
            if (k && !isNaN_(b.y) && !l.isEmpty) {
                let n = l.height * (b.y - a.tr.top) / a.tr.height;
                d.eh(l.left, l.top + n, l.right, l.top + n);
                d.d9();
            }
            else {
                d.cg();
            }
        }
        f$ag(a) {
            switch (a.cl) {
                case 0:
                    a.cu.d5();
                    this.f$an(a);
                    a.cu.cd();
                    break;
                case 1:
                    a.cu.d7();
                    a.cu.ck();
                    this.f$an(a);
                    a.cu.cc();
                    break;
                case 2:
                    a.cu.d7();
                    a.cu.ck();
                    this.f$an(a);
                    a.cu.ce();
                    break;
            }
        }
        f$q(a, b) {
            if (b.x >= 0 && b.y >= 0 && b.x <= a.t6.width && b.y <= a.t6.height) {
                this.ae(a, b);
            }
            else {
                a.ma();
            }
        }
        ae(a, b) {
            let c = a.cu;
            let d = a.t6;
            if (a.eg || a.ef) {
                return;
            }
            if (a.dx && a.d3) {
                let e = d.height > d.width;
                c.bv(e);
                for (let f of fromEnum(a.series)) {
                    if (f.isStacked) {
                        f.n6((g) => {
                            if (g._visibility == 0) {
                                g.p3(b, runOn(c, c.bm));
                            }
                            if (g.dw) {
                                g.n4((h) => {
                                    if (h._visibility == 0) {
                                        h.p3(b, runOn(c, c.bm));
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    else if (f.dw) {
                        if (f._visibility == 0) {
                            if (f._visibility == 0) {
                                f.p3(b, runOn(c, c.bm));
                            }
                        }
                        f.n4((g) => {
                            if (g._visibility == 0) {
                                g.p3(b, runOn(c, c.bm));
                            }
                            return true;
                        });
                    }
                    else {
                        if (f._visibility == 0) {
                            f.p3(b, runOn(c, c.bm));
                        }
                    }
                }
                c.ea();
            }
        }
        ad(a, b) {
            if (a.d3 || a.ed) {
                a.dx = true;
                a.oc();
                this.aj = new Rect(0, b.x, b.y, 0, 0);
                this.al = new Rect(0, b.x, b.y, 0, 0);
                a.cl = 0;
                a.l1(a.tl(b));
            }
        }
        f$ae(a, b) {
            this.ad(a, b);
            this.ae(a, b);
            this.f$an(a);
        }
        f$r(a, b, c) {
            if (!a.dx) {
                this.ag(a, b, c);
            }
        }
        f$p(a, b) {
            this.ak = Rect.empty;
            a.ma();
        }
        f$al(a) {
            if (this.j) {
                this.f$b.onScrollbarDragCancel();
                this.j = false;
            }
            let b = a.cu;
            this.s = 1;
            this.ac(a);
            a.cl = 0;
            this.i = true;
            a.e8 = true;
            a.od();
        }
        ac(a) {
            let b = a.cu;
            a.dx = false;
            b.cj();
            b.cf();
            b.ch();
            a.l1({ $type: Point_$type, x: NaN, y: NaN });
            b.cg();
            b.cl();
            b.ck();
        }
        f$ad(a, b) {
            this.f$al(a);
        }
        f$am(a, b, c, d, e) {
            this.t = b.x;
            this.u = b.y;
            this.q = c;
            this.r = d;
            this.p = e;
            this.ai = a.tr;
            this.f$al(a);
        }
        f$ac(a, b) {
            let c = a.cu;
            c.cg();
            c.cl();
            if (c.av) {
                this.y(a, b);
            }
            else {
                this.aa(a, b);
                this.s = b;
            }
        }
        f$ai(a, b, c, d, e) {
            let f = a.cu;
            f.cg();
            f.cl();
            this.q = this.q * c;
            this.r = this.r * d;
            this.p = this.p * e;
            if (a.em) {
                this.q = this.p;
                this.r = this.p;
            }
            let g = a.tr;
            let h = a.t6;
            let i = b.x - this.t;
            let j = b.y - this.u;
            this.t = b.x;
            this.u = b.y;
            let k = g.width;
            let l = g.height;
            let m = this.ai.width / this.q;
            let n = this.ai.height / this.r;
            if (m > 1) {
                m = 1;
            }
            if (n > 1) {
                n = 1;
            }
            let o = { $type: Point_$type, x: b.x, y: b.y };
            let p = { $type: Point_$type, x: (o.x - h.left) / h.width * g.width + g.left, y: (o.y - h.top) / h.height * g.height + g.top };
            let q = new Rect(0, g.left, g.top, m, n);
            let r = { $type: Point_$type, x: (p.x - q.left) / q.width * h.width + h.left, y: (p.y - q.top) / q.height * h.height + h.top };
            let s = (r.x - o.x) - i;
            let t = (r.y - o.y) - j;
            let u = s / h.width * q.width;
            let v = t / h.height * q.height;
            q = new Rect(0, q.left + u, q.top + v, q.width, q.height);
            g = q;
            a.py(g, true);
        }
        f$z(a, b) {
            this.aj = new Rect(0, b.x, b.y, 0, 0);
            this.al = new Rect(0, b.x, b.y, 0, 0);
        }
        z(a, b, c) {
            let d = a.tr.width;
            let e = a.tr.height;
            let f = a.tr.left + d / 2;
            let g = a.tr.top + e / 2;
            d = d / b;
            e = e / b;
            let h = f - d / 2;
            let i = g - e / 2;
            a.py(new Rect(0, h, i, d, e), true);
        }
        f$ab(a, b) {
            let c = a.cu;
            if (c.av) {
                this.y(a, b);
            }
            else {
                this.aa(a, b);
            }
            this.aj = Rect.empty;
            a.e8 = false;
        }
        f$s(a, b) {
            a.e8 = false;
            this.aj = Rect.empty;
            a.ma();
        }
        f$y(a, b) {
            a.lu();
        }
        f$ah(a, b, c, d, e) {
            a.e8 = false;
            this.aj = Rect.empty;
            a.ma();
        }
        y(a, b) {
            let c = a.t7;
            let d = 1 / b;
            let e = { $type: Point_$type, x: c.x + c.width / 2, y: c.y + c.height / 2 };
            let f = { $type: Point_$type, x: c.x - e.x, y: c.y - e.y };
            let g = new Rect(0, f.x * d + e.x, f.y * d + e.y, c.width * d, c.height * d);
            a.py(g, true);
        }
        aa(a, b) {
            let c = a.t6;
            let d = a.t7;
            let e = b - this.s;
            if (e != 0) {
                let f = 0.03;
                let g = e < 0 ? 1 + f : 1 - f;
                let h = { $type: Point_$type, x: d.x + d.width / 2, y: d.y + d.height / 2 };
                let i = { $type: Point_$type, x: d.x - h.x, y: d.y - h.y };
                let j = new Rect(0, i.x * g + h.x, i.y * g + h.y, d.width * g, d.height * g);
                a.py(j, true);
            }
        }
        f$n(a, b, c) {
            if (!a.e8) {
                this.i = false;
            }
            let d = false;
            if (a.dy) {
                if (this.f$b.shouldHandleInteraction(b, c)) {
                    this.j = true;
                    d = true;
                    this.ac(a);
                    a.cu.dr();
                    return;
                }
            }
            this.ag(a, b, c);
            a.nt(b, c);
        }
        ag(a, b, c) {
            let d;
            let e = a.cu;
            let f = a.cj(c);
            if (e.ez == 0) {
                switch (f) {
                    case 1:
                        d = a.eu() ? f : 0;
                        break;
                    default:
                        d = f;
                        break;
                }
            }
            else {
                if (e.ez == a.sr) {
                    d = 1;
                }
                else if (e.ez == a.ss) {
                    d = 2;
                }
                else {
                    d = 0;
                }
            }
            switch (d) {
                case 1:
                case 2:
                    a.cu.ca();
                    a.cu.dr();
                    break;
            }
            a.cl = d;
            switch (a.cl) {
                case 1:
                    a.l1({ $type: Point_$type, x: NaN, y: NaN });
                    this.aj = new Rect(0, b.x, b.y, 0, 0);
                    this.al = new Rect(0, b.x, b.y, 0, 0);
                    this.ak = new Rect(0, b.x, b.y, 0, 0);
                    e.d8();
                    e.eg(this.aj);
                    a.oi(Rect.empty, true);
                    break;
                case 2:
                    this.aj = new Rect(0, b.x, b.y, 0, 0);
                    this.ak = new Rect(0, b.x, b.y, 0, 0);
                    break;
            }
            this.am = a.tr;
            a.t8 = a.tr;
        }
        f$ak(a) {
            a.pi();
            a.cu.dl();
        }
        f$aj(a) {
            a.l5();
            a.cu.dk();
        }
        f$ap(a) {
            if (a.dt && !this.l) {
                this.l = true;
                this.af(a);
            }
        }
        f$k(a) {
            if (this.l) {
                this.ab(a);
                this.l = false;
            }
        }
        f$h(a) {
            if (this.f == null) {
                return;
            }
            this.g.ab();
        }
        get g() {
            return this.f;
        }
        af(a) {
            if (this.f == null) {
                this.f = new TileZoomManager(a, true, a.hy);
                this.f.h = !a.e9;
            }
            a.ec = true;
            a.oh();
            this.f.al();
            a.cu.br();
            a.cu.bs();
        }
        ab(a) {
            if (this.f == null) {
                return;
            }
            a.ec = false;
            a.cu.dg();
            this.f.ah();
            a.o2();
            a.cu.by();
        }
        f$j(a) {
            a.lz();
            a.o4();
        }
        n(a) {
            return a.cl == 2;
        }
        o(a, b) {
            return a.cb == 1 || b || a.dt;
        }
        m(a) {
            return a.cl == 1;
        }
        f$m(a, b, c) {
            let d = a.cu;
            if (this.j) {
                a.a9.onScrollbarDrag(b, c);
                return;
            }
            if (this.aj.isEmpty && c) {
                this.ag(a, b, c);
            }
            let e = 2;
            if (c) {
                e = 10;
            }
            let f = false;
            let g = new Rect(2, { $type: Point_$type, x: this.aj.x, y: this.aj.y }, b);
            let h = new Rect(0, 0, 0, 0, 0);
            if (!this.ak.isEmpty) {
                h = new Rect(2, { $type: Point_$type, x: this.ak.x, y: this.ak.y }, b);
            }
            if (h.width > e && h.height > e) {
                f = true;
            }
            if (!a.e8) {
                if (f) {
                    this.i = false;
                }
            }
            if (!a.e8 && (a.dx || !c)) {
                a.l1(a.tl(b));
            }
            if (this.m(a)) {
                if (f) {
                    let i = a.t5(g);
                    a.oi(i, true);
                }
                else {
                    a.oi(Rect.empty, true);
                }
                a.m1();
                d.eg(g);
            }
            let j = a.t6;
            let k = a.tr;
            if (this.n(a)) {
                let l = j;
                let m = k.left + k.width * (this.aj.x - b.x) / l.width;
                let n = k.top + k.height * (this.aj.y - b.y) / l.height;
                let o = new Rect(0, m, n, k.width, k.height);
                if (this.o(a, c)) {
                    if (h.width != 0 || h.height != 0) {
                        a.od();
                    }
                    a.oi(Rect.empty, true);
                    let p = a.tr;
                    a.py(o, true);
                    let q = a.tr;
                    if (p.equals1(q) && a.cu.k.ac) {
                        a.cu.k.au();
                    }
                    this.aj = new Rect(3, b, new Size(1, 0, 0));
                    this.al = new Rect(3, b, new Size(1, 0, 0));
                }
                else {
                    a.oi(o, true);
                }
            }
            this.al = new Rect(3, b, new Size(1, 0, 0));
            d.bu(b);
        }
        f$l(a, b, c, d) {
            let e = a.cu;
            let f = 2;
            if (c) {
                f = 10;
            }
            let g = a.t6;
            let h = a.tr;
            if (!d) {
                if (this.j) {
                    this.f$b.onScrollbarDragComplete(b, c);
                    this.j = false;
                    e.bw();
                    return;
                }
            }
            if (!this.i) {
                let i = false;
                let j = new Rect(2, { $type: Point_$type, x: this.aj.x, y: this.aj.y }, b);
                if (j.width > f && j.height > f) {
                    i = true;
                }
                if (a.cl == 1) {
                    a.m0();
                    e.cf();
                    if (i) {
                        a.py(a.t5(j), true);
                    }
                }
                if (a.cl == 2) {
                    let k = g;
                    let l = h.left + h.width * (this.aj.x - b.x) / k.width;
                    let m = h.top + h.height * (this.aj.y - b.y) / k.height;
                    a.py(new Rect(0, l, m, h.width, h.height), true);
                }
            }
            let n = false;
            let o = new Rect(2, { $type: Point_$type, x: this.ak.x, y: this.ak.y }, b);
            if (o.width > f || o.height > f) {
                n = true;
            }
            if (n) {
                a.fh = true;
            }
            a.cl = 0;
            a.oi(Rect.empty, true);
            e.bw();
            a.fh = false;
            e.cg();
            e.cl();
            if (c) {
                e.ck();
                e.cg();
                e.cl();
                e.ch();
            }
            a.ma();
            a.oc();
            a.nu(b, c, d);
        }
        f$af(a) {
            if (this.g != null) {
                this.g.h = !a.e9;
            }
        }
        f$e(a, b) {
            let c = a.cu;
            let d = a.tr;
            if (a.cl == 2 && b == 8) {
                c.bt();
                a.cl = 0;
                a.oc();
                a.oi(Rect.empty, true);
                if (a.cb == 1) {
                    a.py(this.am, true);
                }
                return true;
            }
            if (a.cl == 1 && b == 8) {
                c.bt();
                a.cl = 0;
                a.oc();
                c.cf();
                a.oi(Rect.empty, true);
                return true;
            }
            let e = Rect.empty;
            let f = false;
            switch (b) {
                case 13:
                    f = true;
                    e = new Rect(0, 0, 0, 1, 1);
                    break;
                case 11:
                    f = true;
                    e = new Rect(0, d.left - 0.1 * d.width, d.top - 0.1 * d.height, 1.2 * d.width, 1.2 * d.height);
                    break;
                case 10:
                    f = true;
                    e = new Rect(0, d.left + 0.1 * d.width, d.top + 0.1 * d.height, 0.8 * d.width, 0.8 * d.height);
                    break;
                case 14:
                    f = true;
                    e = new Rect(0, d.left - 0.1 * d.width, d.top, d.width, d.height);
                    e.x = e.x - Math.min(e.left, 0);
                    break;
                case 16:
                    f = true;
                    e = new Rect(0, d.left + 0.1 * d.width, d.top, d.width, d.height);
                    e.x = e.x - Math.max(e.right - 1, 0);
                    break;
                case 15:
                    f = true;
                    e = new Rect(0, d.left, d.top - 0.1 * d.height, d.width, d.height);
                    e.y = e.y - Math.min(e.top, 0);
                    break;
                case 17:
                    f = true;
                    e = new Rect(0, d.left, d.top + 0.1 * d.height, d.width, d.height);
                    e.y = e.y - Math.max(e.bottom - 1, 0);
                    break;
            }
            if (!e.isEmpty && Rect.l_op_Inequality(e, d)) {
                a.py(e, true);
            }
            return f;
        }
        f$f(a, b, c) {
            let d = a.cu;
            let e = a.tr;
            let f = e.left + e.width * b.x / a.t6.width;
            let g = e.top + e.height * b.y / a.t6.height;
            let h = 1 - MathUtil.d(c, -0.5, 0.5);
            let i = Math.max(0, f - h * (f - e.left));
            let j = Math.min(1, g + h * (e.bottom - g));
            let k = Math.min(1, f + h * (e.right - f));
            let l = Math.max(0, g - h * (g - e.top));
            a.od();
            this.x(a, 1000);
            a.py(new Rect(0, i, l, k - i, j - l), true);
            return a.eu();
        }
        x(a, b) {
            a.cu.bz(b);
        }
        f$o(a, b) {
            let c = a.tr;
            let d = c.left + c.width * b.x / a.t6.width;
            let e = c.top + c.height * b.y / a.t6.height;
            let f = 0.7;
            let g = Math.max(0, d - f * (d - c.left));
            let h = Math.min(1, e + f * (c.bottom - e));
            let i = Math.min(1, d + f * (c.right - d));
            let j = Math.max(0, e - f * (e - c.top));
            a.py(new Rect(0, g, j, i - g, h - j), true);
        }
        f$i(a) {
            this.g.ac();
        }
        f$c(a, b, c, d, e, f, g) {
            let h = true;
            let i = false;
            let j = false;
            let k = a;
            if (k.au == 1) {
                h = false;
                i = true;
            }
            if (k.au == 3 || k.au == 4) {
                i = true;
            }
            if (k.au == 4) {
                j = true;
            }
            let l = truncate(Math.round(d.x));
            let m = truncate(Math.round(d.y));
            f = null;
            let n = -1;
            if (h && c != null) {
                let o = l;
                let p = m;
                if (a.gi != 1) {
                    o = truncate(Math.round(d.x * a.gi));
                    p = truncate(Math.round(d.y * a.gi));
                }
                let q = c.a(o, p);
                if (q == null || q.length == 0) {
                    f = null;
                    return {
                        ret: null,
                        p5: f
                    };
                }
                if ((q[0] > 0 || q[1] > 0 || q[2] > 0) && q[3] == 255) {
                    let num2_ = q[2];
                    if (num2_ % 4 != 0) {
                        num2_ = num2_ + (4 - (num2_ % 4));
                    }
                    let num1_ = q[1];
                    if (num1_ % 4 != 0) {
                        num1_ = num1_ + (4 - (num1_ % 4));
                    }
                    let num0_ = q[0];
                    if (num0_ % 4 != 0) {
                        num0_ = num0_ + (4 - (num0_ % 4));
                    }
                    let num_ = 0;
                    num_ = (num2_ >> 2);
                    num_ = (num_ << 6);
                    num_ = (num_ | (num1_ >> 2));
                    num_ = (num_ << 6);
                    num_ = (num_ | (num0_ >> 2));
                    n = truncate(Math.floor((intDivide(num_, 1000))));
                    n--;
                }
            }
            let r = null;
            let s = -1;
            if (n >= 0) {
                let t = false;
                let u = 0;
                for (let v of fromEnum(b)) {
                    if (!v.fl) {
                        continue;
                    }
                    if (t) {
                        break;
                    }
                    if (v.isStacked) {
                        v.n6((w) => {
                            if (w.jm == n) {
                                r = w;
                                s = u;
                                t = true;
                                return false;
                            }
                            return true;
                        });
                    }
                    else if (v.jm == n) {
                        r = v;
                        s = u;
                        break;
                    }
                    u++;
                }
            }
            let w = null;
            if (i) {
                let x = false;
                for (let y = b.count - 1; y >= 0; y--) {
                    let z = b._inner[y];
                    if (!z.fl) {
                        continue;
                    }
                    let aa = z.cg;
                    if (!z.gm(aa.bx, aa.by, aa)) {
                        continue;
                    }
                    if (!x && y < s && h && !j) {
                        if (r != null) {
                            w = r;
                            x = true;
                            break;
                        }
                    }
                    if (z != null && z.bt == 1) {
                        if (z.f5(d, g)) {
                            w = z;
                            break;
                        }
                    }
                }
                if (h && !x) {
                    if (r != null) {
                        w = r;
                        x = true;
                    }
                }
            }
            else {
                w = r;
            }
            if (w != null) {
                let ab = w.au({ $type: Point_$type, x: l, y: m }, g);
                if (ab != null) {
                    f = ab;
                }
                return {
                    ret: w,
                    p5: f
                };
            }
            return {
                ret: null,
                p5: f
            };
        }
        f$g(a, b) {
            if (PointUtil.equals(b, null)) {
                return false;
            }
            let c = b.x;
            let d = b.y;
            if (this.j) {
                return true;
            }
            if (c >= a.t6.left && d >= a.t6.top && c <= a.t6.left + a.t6.width && d <= a.t6.top + a.t6.height) {
                let e = a.cn;
                if (e != null && e.viewShouldInteract(b)) {
                    return false;
                }
                return true;
            }
            return false;
        }
        b(a) {
            if (a != null) {
                return a.bh();
            }
            else {
                return null;
            }
        }
        f$w(a, b, c, d, e, f) {
            if (!f && a.ds) {
                this.ah(a, false);
            }
            let g = new MouseEventArgs();
            g.position = d;
            if (a.cl == 2 || a.cl == 1 || a.e8 || (a.cn != null && a.cn.isPinching)) {
                if (this.c != null) {
                    this.c.a3.a$z(this.c, g.position, this.a, g, f);
                    this.c = null;
                }
                return;
            }
            let h = null;
            let i = ((() => { let j = this.f$c(a, b, c, d, !e, h, f); h = j.p5; return j.ret; })());
            this.a = h;
            let j = this.b(i);
            if (i != null) {
                let k = false;
                let l = false;
                if (this.c != i) {
                    l = true;
                }
                if (this.c == null || l) {
                    k = true;
                }
                if (k) {
                    if (l) {
                        if (this.c != null) {
                            j = this.b(this.c);
                            this.c.a3.a$z(this.c, g.position, h, g, f);
                            if (j != null) {
                                j.a3.a$z(j, g.position, h, g, f);
                            }
                        }
                    }
                    this.c = i;
                    i.ov(g.position, h, g, f);
                    if (j != null) {
                        j.ov(g.position, h, g, f);
                    }
                }
                else {
                    this.c = i;
                    i.a3.a$ab(i, g.position, h, g, f);
                    if (j != null) {
                        j.a3.a$ab(j, g.position, h, g, f);
                    }
                }
            }
            else {
                if (this.c != null) {
                    j = this.b(this.c);
                    this.c.a3.a$z(this.c, g.position, h, g, f);
                    if (j != null) {
                        j.a3.a$z(j, g.position, h, g, f);
                    }
                    this.c = null;
                }
                for (let m = 0; m < a.series.count; m++) {
                    let n = a.series._inner[m];
                    if (n.a3.a$b) {
                        j = this.b(n);
                        n.a3.a$z(n, g.position, n.a3.a$p, g, f);
                        if (j != null) {
                            j.a3.a$z(j, g.position, n.a3.a$p, g, f);
                        }
                    }
                }
            }
        }
        f$v(a, b) {
            if (this.c != null) {
                let c = this.b(this.c);
                let d = new MouseEventArgs();
                d.position = b;
                this.c.a3.a$z(this.c, d.position, null, d, false);
                if (c != null) {
                    c.a3.a$z(c, d.position, null, d, false);
                }
                this.c = null;
            }
            a.no(b, a.cl != 0 || a.ez);
        }
        f$u(a, b, c) {
            if (this.c != null) {
                let d = new MouseButtonEventArgs();
                d.position = c;
                if (b.al) {
                    this.c.a3.a$ac(this.c, d.position, this.a, d);
                }
                else {
                    this.c.a3.a$w(this.c, d.position, this.a, d);
                }
            }
        }
        f$x(a, b, c) {
            let d;
            let e = (this.c != null) ? this.c : ((() => { let f = a.cu.f(c, false, d, false); d = f.p2; return f.ret; })());
            if (e != null) {
                let f = new MouseButtonEventArgs();
                f.position = c;
                if (b.al) {
                    e.a3.a$ad(e, f.position, this.a, f);
                }
                else {
                    e.a3.a$aa(e, f.position, this.a, f);
                }
            }
        }
        f$t(a, b, c) {
            if (!c && a.e1) {
                this.ah(a, false);
            }
            if (c && !a.e1) {
                this.ah(a, true);
            }
            a.m5(b, c);
        }
        ah(a, b) {
            if (a != null) {
                if (!this.k) {
                    a.ds = b;
                }
            }
        }
        f$aa(a, b) {
            this.h = true;
        }
        get k() {
            return this.h;
        }
    }
    SeriesViewerInteractionManager.$t = /*@__PURE__*/ markType(SeriesViewerInteractionManager, 'SeriesViewerInteractionManager', Base.$, [ISeriesViewerInteractionManager_$type]);
    return SeriesViewerInteractionManager;
})();
